package moncheck2;

import java.awt.Dimension;
import java.awt.GridLayout;
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URL;
import java.text.NumberFormat;
import java.util.Random;
import java.util.jar.JarFile;

import javax.swing.BorderFactory;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.Border;

public class CarloCompute extends CarloAbstract {
	JTextField total;
	JTextField losttwo_zero ;
	JTextField lostone_zero ;
	JTextField lostone_one ;
	JTextField lostzero_one;
	JTextField lostzero_two;
	JTextField one_diff;
	JTextField one_ratio;
	JTextField one_var_diff;
	JTextField zwo_diff;
	JTextField zwo_ratio;
	JTextField zwo_var_diff;
	JComboBox combox1;
	JComboBox combox2;
	static int attac1;
	static int attac2;
	
	public CarloCompute() {
		//Constructor stub
	}	
	public Result getInstCoResult() {
		return (new Result());
	}
	
	public JPanel makeGuiPanel(JPanel panel) {
		total = new JTextField(7);
		total.setHorizontalAlignment(JTextField.RIGHT);
		losttwo_zero = new JTextField(5);
		lostone_zero = new JTextField(5);
		lostone_one = new JTextField(5);
		lostzero_one = new JTextField(5);
		lostzero_two = new JTextField(5);
		one_diff = new JTextField(5);
		one_ratio = new JTextField(5);
		one_var_diff = new JTextField(5);
		zwo_diff = new JTextField(5);
		zwo_ratio = new JTextField(5);
		zwo_var_diff = new JTextField(5);
		JPanel wuerfel = new JPanel();
		wuerfel.setPreferredSize(new Dimension(75,23));
		String[] dicel = {"1" , "2", "3", "4", "5", "6"};
	    combox1 = new JComboBox(dicel);
	    combox1.setPreferredSize(new Dimension(35,18));
	    combox2 = new JComboBox(dicel);
	    combox2.setPreferredSize(new Dimension(35,18));
	    GridLayout grid = new GridLayout(4,8);
		grid.setHgap(10);
		panel.setLayout(grid);
		Border border10 = BorderFactory.createEmptyBorder(10,10, 10, 10);
		panel.setBorder(border10);
		panel.add(new JLabel("Angreifer:",JLabel.CENTER));
		panel.add(new JLabel(""));
		panel.add(new JLabel("1:0",JLabel.CENTER));
		panel.add(new JLabel("0:1",JLabel.CENTER));
		panel.add(new JLabel(""));
		panel.add(new JLabel("E(eig.V-geg.V)",JLabel.CENTER));
		panel.add(new JLabel("S(eig.V-geg.V)",JLabel.CENTER));
		panel.add(new JLabel("E(eig.V:geg.V)",JLabel.CENTER));
		wuerfel.add(combox1);
		wuerfel.add(combox2);
		panel.add(wuerfel);
		panel.add(new JLabel("Ein Würfel",JLabel.RIGHT));
		panel.add(lostone_zero);
		panel.add(lostzero_one);
		panel.add(new JLabel(""));
		panel.add(one_diff);
		panel.add(one_var_diff);
		panel.add(one_ratio);
		panel.add(new JLabel("Gesamt",JLabel.CENTER));
		panel.add(new JLabel(""));
		panel.add(new JLabel("2:0",JLabel.CENTER));
		panel.add(new JLabel("1:1",JLabel.CENTER));
		panel.add(new JLabel("0:2",JLabel.CENTER));
		panel.add(new JLabel("E(eig.V-geg.V)",JLabel.CENTER));
		panel.add(new JLabel("S(eig.V-geg.V)",JLabel.CENTER));
		panel.add(new JLabel("E(eig.V:geg.V)",JLabel.CENTER));
		panel.add(total);
		panel.add(new JLabel("Zwei Würfel",JLabel.RIGHT));
		panel.add(losttwo_zero);
		panel.add(lostone_one);
		panel.add(lostzero_two);
		panel.add(zwo_diff);
		panel.add(zwo_var_diff);
		panel.add(zwo_ratio);
		return panel;
		
	}
	
	public void enableUI(boolean enabled) {
		combox1.setEnabled(enabled);
		combox2.setEnabled(enabled);
	}
	
	public void updateDisplay(AbsResult displ) {
		NumberFormat nf = NumberFormat.getInstance();
		nf.setMaximumFractionDigits(5);
		Result displres = (Result)displ;	
		total.setText(Long.toString(displres.getTotal()));
		if (displres.getTotal() != 0) {
			float e_one_diff = ((float)displres.getLostone_zero()-(float)displres.getLostzero_one())/(float)displres.getTotal();                          ;
			float lone_zero = (float)displres.getLostone_zero()/(float)displres.getTotal();
			float lzero_one = (float)displres.getLostzero_one()/(float)displres.getTotal();
			lostone_zero.setText(nf.format(lone_zero));	
			lostzero_one.setText(nf.format(lzero_one));
			one_diff.setText(nf.format(e_one_diff));
			one_var_diff.setText(nf.format(Math.sqrt(lone_zero+lzero_one - Math.pow(e_one_diff,2) )));
			one_ratio.setText(nf.format((float)displres.getLostone_zero()/(float)displres.getLostzero_one()));
			
			float e_zwo_diff =  ((float)displres.getLosttwo_zero()*2-(float)displres.getLostzero_two()*2)/(float)displres.getTotal();
			float ltwo_zero = (float)displres.getLosttwo_zero()/(float)displres.getTotal();
			float lone_one = (float)displres.getLostone_one()/(float)displres.getTotal();
			float lzero_two = (float)displres.getLostzero_two()/(float)displres.getTotal();
			losttwo_zero.setText(nf.format(ltwo_zero));	
			lostone_one.setText(nf.format(lone_one));
			lostzero_two.setText(nf.format(lzero_two));
			zwo_diff.setText(nf.format(e_zwo_diff));
			zwo_var_diff.setText(nf.format(Math.sqrt(ltwo_zero*4+ lzero_two*4 - Math.pow(e_zwo_diff, 2)) ));
			zwo_ratio.setText(nf.format(((float)displres.getLosttwo_zero()*2+(float)displres.getLostone_one())/((float)displres.getLostone_one() +(float)displres.getLostzero_two()*2)));
			
		}
	}
	
	public Result reset() {		
		total.setText("");
		lostone_zero.setText("");	
		lostzero_one.setText("");
		one_diff.setText("");
		one_var_diff.setText("");
		one_ratio.setText("");			
		losttwo_zero.setText("");	
		lostone_one.setText("");
		lostzero_two.setText("");
		zwo_diff.setText("");
		zwo_var_diff.setText("");
		zwo_ratio.setText("");
		return(new Result());		
	}
	
	public void setParams() {
		attac1 = combox1.getSelectedIndex()+1;
		attac2 = combox2.getSelectedIndex()+1;
	}
	
	
	public Result compute() {
		Random rand = new Random();
		Result res = new Result();
		//int attac1 = 2;
		//int attac2 = 5;
		int defend1 = rand.nextInt(6)+1;
		int defend2 = rand.nextInt(6)+1;
		int defendsolo = rand.nextInt(6)+1;
		if (first(attac1,attac2)>first(defend1,defend2)) {
			if (sec(attac1,attac2)>sec(defend1,defend2)) {
				res.setLosttwo_zero(1);
			} else {
				res.setLostone_one(1);
			}
		}  else {
			if (sec(attac1,attac2)>sec(defend1,defend2)) {
				res.setLostone_one(1);
			} else {
				res.setLostzero_two(1);
			}
		}
		
		
		if (defendsolo >= first(attac1, attac2)) {
		res.setLostzero_one(1); }
		else {res.setLostone_zero(1);}
		res.setTotal(1); 
		return(res);
	}
	
	
	
	public static int first(int erste, int zweite, int dritte) {
		if (dritte >= zweite &&  dritte >= erste ) {
			return(dritte);
		} else if (zweite >= erste && zweite >= dritte) {
			return(zweite);
		} else {
			return(erste);
		}	
	}
	
	public static int first(int erste, int zweite) {
		return (first(erste,zweite,0));
	}
	
	public static int sec(int erste, int zweite, int dritte) {
		if (erste == first(erste, zweite, dritte) ) {
			if (zweite >= dritte) {
				return(zweite);
			} else {
				return(dritte);
			}			
		} else if (zweite == first (erste,zweite,dritte)) {
			if (erste >= dritte) {
				return(erste);
			} else {
				return(dritte);
			}
		} else {
			if (erste >= zweite) {
				return(erste);
			} else {
				return(zweite);
			}
		}
	}
	
	public static int sec(int erste, int zweite) {
		return(sec(erste,zweite,0));
	}
	
	
	
	
	public Result add(AbsResult res1, AbsResult res2) {
		
				long a = ((Result)res1).getTotal()+((Result)res2).getTotal();
				long b = ((Result)res1).getLosttwo_zero()+((Result)res2).getLosttwo_zero();
				long c = ((Result)res1).getLostone_zero()+((Result)res2).getLostone_zero();
				long d = ((Result)res1).getLostone_one()+((Result)res2).getLostone_one();
				long e = ((Result)res1).getLostzero_one()+((Result)res2).getLostzero_one();
				long f = ((Result)res1).getLostzero_two()+((Result)res2).getLostzero_two();
				
				Result resM = new Result();
				
				resM.setTotal(a);
				resM.setLosttwo_zero(b);
				resM.setLostone_zero(c);
				resM.setLostone_one(d);
				resM.setLostzero_one(e);
				resM.setLostzero_two(f);
				
				return resM;
	}
	
	public String getHelpText() {

		String hilfetext = "", hilfezeile;
		String helpfilename = "Hilfe-Risiko.txt";
		InputStream is;	
		ClassLoader cl = this.getClass().getClassLoader();		
		
		try {
			is = (cl.getResource(helpfilename)).openStream();			
			/* 
			String u =  getClass().getProtectionDomain().getCodeSource().getLocation().getFile();
			System.out.println(u);
			if (u.contains(".jar")) {
				JarFile jf = new JarFile(u);
				is = jf.getInputStream(jf.getJarEntry(helpfilename));
			} else {
				is = new FileInputStream(helpfilename);
			}
			*/
			BufferedReader buffr = new BufferedReader(new InputStreamReader(is , "UTF-8")); 
			while ((hilfezeile = buffr.readLine()) != null) {
				hilfetext=hilfetext+hilfezeile + "\n";
			}
		} catch (IOException exc) {
			System.err.print("Hilfedatei konnte nicht geöffnet werden.\n");	
			return("Hilfedatei konnte nicht geöffnet werden.");
		} 		
		return (hilfetext); 
	}

}
