package moncheck2;

import java.io.File;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import qdxml.DocHandler;
import qdxml.QDParser;

public class StratInput implements DocHandler {
	final static int NONE = 0;
	final static int STRAT = 1;
	final static int PAIR = 2;
	final static int ERR = 9;
	int status = 0;
	int A1;
	int A2;
	boolean isexact;
	Strategie strat;
	public ArrayList<Strategie.Pair> spl;
	
	public void startDocument() {
		//System.out.println("  start document");
	}
	public void endDocument() {
		//System.out.println("  end document");
	}
	public void startElement(String elem,Hashtable h) {
		//System.out.println("    start elem: "+elem);
		if (elem.equals("strategie") && status == NONE) {
			//System.out.println(elem);
			status = STRAT;
		}
		if (elem.equals("pair") && status == STRAT) {
			status = PAIR;
		}

		Enumeration e = h.keys();
		while(e.hasMoreElements()) {
			String key = (String)e.nextElement();
			String val = (String)h.get(key);
			//System.out.println("      "+key+" = "+val);
			if (key.equals("type") && status == PAIR) {
				if (val.equals("exact")) { isexact=true; } else {isexact = false;}
			}
		}
		//System.out.println(status);
	}
	public void endElement(String elem) {
		//System.out.println("    end elem: "+elem);
		if (status == STRAT && elem.equals("strategie")) {
			status = NONE;
		}
		if (status == PAIR && elem.equals("pair")) {
			status = STRAT;    	
			savePair(); 
		}
	}
	public void text(String text) {
		if (status == PAIR) {
			Pattern pat = Pattern.compile(".*([123456]);([123456]).*");
			Matcher m = pat.matcher(text);
			m.matches();
			A1=Integer.parseInt(m.group(1));
			A2=Integer.parseInt(m.group(2));
			System.out.println("Pair: "+A1+";"+A2+" Exact: "+isexact);	    
		}
	}
	// implementation of DocHandler is above this line

	public ArrayList<Strategie.Pair> getStratPairList(Strategie strat, File file) throws Exception{
		this.strat = strat;
		//System.out.println("file: "+file);
		spl = new ArrayList<Strategie.Pair>();
		FileReader fr = new FileReader(file.getCanonicalFile());
		QDParser.parse(this,fr);
		fr.close();
		return spl;
	}
	public void savePair() {
		spl.add(strat.new Pair(A1,A2,isexact)); 
		A1 = 0;
		A2 = 0;
		isexact = false;
	}

}
