package moncheck2;

import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Random;

import javax.swing.BorderFactory;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.Border;


public class Strategie extends CarloAbstract implements ActionListener {

	JTextField total;
	JTextField respone;
	JTextField resptwo;
	JTextField losttwo_zero ;
	JTextField lostone_zero ;
	JTextField lostone_one ;
	JTextField lostzero_one;
	JTextField lostzero_two;
	JTextField diff;
	JTextField ratio;
	JTextField var_diff;
	JComboBox stratbox;
	int stratnr;
	ArrayList<Pair> margpairs;
	
	public Strategie() {}
	
	@Override
	public AbsResult getInstCoResult() {
		return new ResultStrategie();
	}
	
	@Override
	public JPanel makeGuiPanel(JPanel panel) {
		total = new JTextField(7);
		total.setHorizontalAlignment(JTextField.RIGHT);
		respone = new JTextField(7);
		resptwo = new JTextField(7);
		losttwo_zero = new JTextField(5);
		lostone_zero = new JTextField(5);
		lostone_one = new JTextField(5);
		lostzero_one = new JTextField(5);
		lostzero_two = new JTextField(5);
		diff = new JTextField(5);
		ratio = new JTextField(5);
		var_diff = new JTextField(5);
		GridLayout grid = new GridLayout(4,8);
		grid.setHgap(10);
		panel.setLayout(grid);
		Border border10 = BorderFactory.createEmptyBorder(10,10, 10, 10);
		
		String[] stratlist = {"6/3 u. 5/4" , "6/3 u. 5/5", "5/4", "6/4 u. 5/5", "5/5", "6/5", "6/6", "6/4;5/4;4/4", "6/6;5/5;4/4", "nie", "aus File"};
	    stratbox = new JComboBox(stratlist);
	    stratbox.setPreferredSize(new Dimension(40,18));
		stratbox.addActionListener(this);
		
		panel.setBorder(border10);
		panel.add(new JLabel("Strategie:",JLabel.RIGHT));
		panel.add(new JLabel("nur 1 Würfel ab"));
		panel.add(stratbox);
		
		panel.add(new JLabel(""));
		panel.add(new JLabel(""));	
		panel.add(new JLabel("Gesamt",JLabel.CENTER));
		panel.add(new JLabel("1 Würfel",JLabel.CENTER));
		panel.add(new JLabel("2 Würfel",JLabel.CENTER));

		panel.add(new JLabel(""));
		panel.add(new JLabel(""));
		panel.add(new JLabel(""));
		panel.add(new JLabel(""));
		panel.add(new JLabel(""));
		panel.add(total);
		panel.add(respone);
		panel.add(resptwo);
	
		panel.add(new JLabel("1:0",JLabel.CENTER));
		panel.add(new JLabel("0:1",JLabel.CENTER));
		panel.add(new JLabel("2:0",JLabel.CENTER));
		panel.add(new JLabel("1:1",JLabel.CENTER));
		panel.add(new JLabel("0:2",JLabel.CENTER));
		panel.add(new JLabel("E(eig.V-geg.V)",JLabel.CENTER));
		panel.add(new JLabel("S(eig.V-geg.V)",JLabel.CENTER));
		panel.add(new JLabel("E(eig.V:geg.V)",JLabel.CENTER));

		panel.add(lostone_zero);
		panel.add(lostzero_one);
		panel.add(losttwo_zero);
		panel.add(lostone_one);
		panel.add(lostzero_two);
		panel.add(diff);
		panel.add(var_diff);
		panel.add(ratio);
		return panel;
	}

	public void actionPerformed(ActionEvent e) {
		if (stratbox.getSelectedIndex()==10) {		
			JFileChooser jfc = new JFileChooser();
			File file = null;
			try {
				if (jfc.showOpenDialog(total) == JFileChooser.CANCEL_OPTION) throw new NullPointerException();
				file = jfc.getSelectedFile();
			} catch (NullPointerException np) {
				System.err.println("Kein Dateiname ausgewählt.");
			} 
			StratInput sinp = new StratInput();
			try {
			margpairs = sinp.getStratPairList(this, file);
			} catch (Exception ex) {
				System.err.println("Parserfehler: "+ ex);
			}			
			//System.out.print(filetxt + "\n");
		}
	}
	
	@Override
	public void enableUI(boolean enabled) {
		stratbox.setEnabled(enabled);
	}

	
	@Override
	public void updateDisplay(AbsResult displ) {
		NumberFormat nf = NumberFormat.getInstance();
		nf.setMaximumFractionDigits(5);
		ResultStrategie displres = (ResultStrategie)displ;	
		total.setText(Long.toString(displres.getTotal()));
		if (displres.getTotal() != 0) {
			float e_one_diff = ((float)displres.getLostone_zero()-(float)displres.getLostzero_one()+(float)displres.getLosttwo_zero()*2-(float)displres.getLostzero_two()*2)/(float)displres.getTotal();                          ;
			float lone_zero = (float)displres.getLostone_zero()/(float)displres.getTotal();
			float lzero_one = (float)displres.getLostzero_one()/(float)displres.getTotal();
			float ltwo_zero = (float)displres.getLosttwo_zero()/(float)displres.getTotal();
			float lone_one = (float)displres.getLostone_one()/(float)displres.getTotal();
			float lzero_two = (float)displres.getLostzero_two()/(float)displres.getTotal();
			lostone_zero.setText(nf.format(lone_zero));	
			lostzero_one.setText(nf.format(lzero_one));
			losttwo_zero.setText(nf.format(ltwo_zero));	
			lostone_one.setText(nf.format(lone_one));
			lostzero_two.setText(nf.format(lzero_two));
			respone.setText(nf.format((float)displres.getRespone()/(float)displres.getTotal() ));
			resptwo.setText(nf.format((float)displres.getResptwo()/(float)displres.getTotal() ));
			diff.setText(nf.format(e_one_diff));
			var_diff.setText(nf.format(Math.sqrt(lone_zero*1+lzero_one*1+ ltwo_zero  *4+  lzero_two  *4 - Math.pow(e_one_diff,2) )));
			ratio.setText(nf.format(((float)displres.getLostone_zero()+(float)displres.getLosttwo_zero()*2+(float)displres.getLostone_one())/((float)displres.getLostzero_one()+ (float)displres.getLostone_one() +(float)displres.getLostzero_two()*2       )));		
		}
		

	}
	
	@Override
	public AbsResult add(AbsResult res1, AbsResult res2) {
		ResultStrategie rsr = new ResultStrategie();
		rsr.setTotal((long)((ResultStrategie)res1).getTotal()+((ResultStrategie)res2).getTotal());
		rsr.setLosttwo_zero((long)((ResultStrategie)res1).getLosttwo_zero()+((ResultStrategie)res2).getLosttwo_zero());
		rsr.setLostone_zero((long)((ResultStrategie)res1).getLostone_zero()+((ResultStrategie)res2).getLostone_zero());
		rsr.setLostone_one((long) ((ResultStrategie)res1).getLostone_one()+((ResultStrategie)res2).getLostone_one());
		rsr.setLostzero_one((long)((ResultStrategie)res1).getLostzero_one()+((ResultStrategie)res2).getLostzero_one());
		rsr.setLostzero_two((long)((ResultStrategie)res1).getLostzero_two()+((ResultStrategie)res2).getLostzero_two());
		rsr.setRespone((long)((ResultStrategie)res1).getRespone()+((ResultStrategie)res2).getRespone());
		rsr.setResptwo((long)((ResultStrategie)res1).getResptwo()+((ResultStrategie)res2).getResptwo());
		//System.out.println("Total: "+rsr.getTotal()+" one: "+rsr.getRespone()+" two: "+rsr.getResptwo());
		return rsr;
	}

	@Override
	public AbsResult compute() {
		Random rand = new Random();
		ResultStrategie res = new ResultStrategie();
		//int attac1 = 2;
		//int attac2 = 5;
		int attac1 = rand.nextInt(6)+1;
		int attac2 = rand.nextInt(6)+1;
		int attac3 = rand.nextInt(6)+1;
		int defend1 = rand.nextInt(6)+1;
		int defend2 = rand.nextInt(6)+1;
		
		
		if (defwithtwo(first(attac1,attac2,attac3),sec(attac1,attac2,attac3))) {
			if (first(attac1,attac2)>first(defend1,defend2)) {
				if (sec(attac1,attac2)>sec(defend1,defend2)) {
					res.setLosttwo_zero(1);
				} else {
					res.setLostone_one(1);
				}
			}  else {
				if (sec(attac1,attac2)>sec(defend1,defend2)) {
					res.setLostone_one(1);
				} else {
					res.setLostzero_two(1);
				}
			}
			res.setResptwo(1);
		}
		else {
		    if (defend1 >= first(attac1, attac2)) {
		      res.setLostzero_one(1); }
		    else {res.setLostone_zero(1);} 
		    res.setRespone(1);
		}
		res.setTotal(1);
	
		return(res);
	}

    private boolean defwithtwo(int first1, int sec2) {
    	if (stratnr == 1) {    	
    		if (first1 == 6 && sec2 >=3) {return (false);}
    		else if (first1 == 5 && sec2 >=4) {return false;}
    		else {return true;}
    	} else if (stratnr == 2) {
    		if (first1 == 6 && sec2 >=3) {return (false);}
    		else if (first1 == 5 && sec2 >=5) {return false;}
    		else {return true;}
    	} else if (stratnr == 3) {
    		if (first1 >= 5 && sec2 >=4) {return (false);}
    		else {return true;}
    	} else if (stratnr == 4)	{
    		if (first1 == 6 && sec2 >=4) {return (false);}
    		else if (first1 == 5 && sec2 >=5) {return false;}
    		else {return true;}
    	} else if (stratnr == 5){
    		if (first1 >= 5 && sec2 >=5) {return (false);}
    		else {return true;}
    	} else if (stratnr == 6) {
    		if (first1 == 6 && sec2 >=5) {return (false);}
    		else {return true;}		
    	} else if (stratnr == 7) { 
    		if (first1 == 6 && sec2 >=6) {return (false);}
    		else {return true;}
    	} else if (stratnr == 8) { 
    		if (sec2 >=4) {return (false);}
    		else {return true;}
    	} else if (stratnr == 9) { 
    		if (first1 == 6 && sec2 ==6) {return (false);}
    		else if (first1== 5 && sec2 >=5) {return false;}
    		else if (first1 == 4 && sec2 >=4) {return false;}
    		else {return true;}
    	}	else if (stratnr == 10) { //nie
    		return(true);
    	}  else if (stratnr == 11) {  //aus File
    		boolean two = true;
    		for (int i=0; i < margpairs.size(); i++) {
    			if (margpairs.get(i).isIsexact()) {
    				if (first(margpairs.get(i).getA1(),margpairs.get(i).getA2()  )==first1 &&  sec(margpairs.get(i).getA1(),margpairs.get(i).getA2())==sec2  ) {
    				two=false; }
    			} else if (first(margpairs.get(i).getA1(),margpairs.get(i).getA2())<=first1 &&  sec(margpairs.get(i).getA1(),margpairs.get(i).getA2())<=sec2) {
    				two=false;
    			}  			   			
    		}
    		return(two);
    	} else { 
    		return false;
    	}
		
    }
    
    
    public static int first(int erste, int zweite, int dritte) {
		if (dritte >= zweite &&  dritte >= erste ) {
			return(dritte);
		} else if (zweite >= erste && zweite >= dritte) {
			return(zweite);
		} else {
			return(erste);
		}	
	}
	
	public static int first(int erste, int zweite) {
		return (first(erste,zweite,0));
	}
	
	public static int sec(int erste, int zweite, int dritte) {
		if (erste == first(erste, zweite, dritte) ) {
			if (zweite >= dritte) {
				return(zweite);
			} else {
				return(dritte);
			}			
		} else if (zweite == first (erste,zweite,dritte)) {
			if (erste >= dritte) {
				return(erste);
			} else {
				return(dritte);
			}
		} else {
			if (erste >= zweite) {
				return(erste);
			} else {
				return(zweite);
			}
		}
	}
	
	public static int sec(int erste, int zweite) {
		return(sec(erste,zweite,0));
	}
	
    

	@Override
	public String getHelpText() {
		return "Strategie-Modus\nIn diesem Modus geht es nicht um einzelne Würfe des Angreifers, sondern einen ganzen Angriff. Zunächst muss festgelegt werden, ab welchen Angreifer-Würfen der Verteidiger nur noch mit einem Würfel gewürfelt wird. Dann kann die Simulation gestartet werden Die Ergebnisse zeigen, in welchem Verhältnis Verteidiger und Angreifer langfristig Armeen verlieren, wenn der Angreifer immer mit 3 Würfeln würfelt und der Verteidiger mit einem oder zweien, entsprechend der eingestellten Strategie.\n\nEine Strategie kann auch aus einem XML-File geladen werden.\nDie Grenzzahlenkombinationen müssen dazu mit Strichpunkt getrennt in einem <pair>-Element innerhalb eines <strategie>-Elementes notiert werden. Die type-Eigenschaft gibt an, ob das Grenzpaar als \"exact\" (bei genau dieser Zahlenkombination wird nur mit einem Würfel gewürfelt) oder \"minimum\" (ab dieser Zahlenkombination aufwärts wird mit einem Würfel gewürfelt) zu verstehen ist. Eine Beispiel-Datei ist im jar-File enthalten.";
	}


	@Override
	public AbsResult reset() {
		total.setText("");
		respone.setText("");
		resptwo.setText("");
		lostone_zero.setText("");	
		lostzero_one.setText("");
		losttwo_zero.setText("");	
		lostone_one.setText("");
		lostzero_two.setText("");
		diff.setText("");
		var_diff.setText("");
		ratio.setText("");	
		return new ResultStrategie();
	}

	@Override
	public void setParams() {
		stratnr = stratbox.getSelectedIndex()+1;
	}

	class Pair {
		int a1;
		int a2;
		boolean isexact;
		
		public Pair(int a1, int a2, boolean isexact) {
			super();
			this.a1 = a1;
			this.a2 = a2;
			this.isexact = isexact;
		}
		public int getA1() {
			return a1;
		}
		public void setA1(int a1) {
			this.a1 = a1;
		}
		public int getA2() {
			return a2;
		}
		public void setA2(int a2) {
			this.a2 = a2;
		}
		public boolean isIsexact() {
			return isexact;
		}
		public void setIsexact(boolean isexact) {
			this.isexact = isexact;
		}
	}

}
